 
 
ti92	equ	0	;0=92+/89, 1=92
 
 	ifne	ti92
	include	"tios.h"
	endif
	ifeq	ti92
	include	"DoorsOs.h"
	xdef	_ti89
	xdef	_ti92plus
	endif
	
	include	"genlib.h"
	include	"mulib.h"

	xdef	_main
	xdef	_comment

_main:

	jsr	genlib::init			; initalise genlib

	genlib::PUSH_DSCREEN d0			; Allocation d'un cran DScreen sur la pile
						; Sauvegarde son adresse dans d0.l
	move.l 	d0,dscreen			; Sauvegarde dans une variable
 	jsr	genlib::set_dscreen_int		; on affiche dscreen

	jsr	genlib::init_dscreen
	move.w	d0,hd
	move.l	a0,d0
	move.l	d0,dscreen2

	jsr	genlib::set_dscreen_function	; on travaille dans dscreen

	jsr	genlib::cls			; On l'efface

	clr.l	d3				; initialise les angles
	clr.l	d4
	clr.l	d5

 bcl:

	cmp.l	#3,genlib::timer		; ajuste la frquence  15 Hz environ
	bls.s	bcl
	clr.l	genlib::timer

	move.l	dscreen2,a1
	move.l	dscreen,dscreen2		; bascule entre les screens
	move.l	a1,dscreen

	move.l	dscreen2,d0
	jsr	genlib::set_dscreen_function
	jsr	genlib::cls

	move.l	dscreen,d0
 	jsr	genlib::set_dscreen_int

	lea	cube(pc),a0			; structure initiale des sommets du cube (cube de 80 px d'arrte)
	lea	cube_rot(pc),a1			; destination (8 pts 3D donc 32 octets)
	clr.l	genlib::timer
	moveq	#8,d7				; nombre de points
	
	jsr	mulib::n_rotate_A 		; calcul des nouvelles coordonnes

	lea	cube_rot(pc),a0			; liste de points obtenue plus haut
	lea	segm(pc),a1			; liste des segments (un cube as 12 arrtes)
	moveq	#12,d7				; nombre de segments
	jsr	mulib::draw_n_lines		; trace les segments

	btst.b	#1,$60001A			; quitte si [on] est appuye 
	beq	exit

	add.b	#2,d4				; incrmente les angles de 1
	add.b	#2,d5				; puisque l'unit est 1/256me de tour, revient  0 tout seul :)
	add.b	#2,d3

	bra	bcl

 exit:

	move.l	dscreen,a1
	lea	title(pc),a0
	moveq	#0,d0
	moveq	#0,d1
	jsr	genlib::put_large_string

	add.l	#$F00,a1
	jsr	genlib::put_large_string

	jsr	genlib::wait_a_key		; Attend une touche

	genlib::POP_DSCREEN			; dpile le premier dscreen

	move.w	hd,-(a7)
	
	ifne	ti92				; compile selon la calc: ici ti92
	jsr	tios::HeapFree			; libre le handle de l'autre
	endif
	ifeq	ti92				; 92+/89
	jsr	_ROM_CALL_097
	endif

	addq.l	#2,a7

	jsr	genlib::quit			; quitte genlib

	rts

	even

cube:						; 3D cube structure (liste de points)

	dc.w	-40,40,40,0		; a 1
	dc.w	40,40,40,0		; b 2
	dc.w	40,40,-40,0		; c 3
	dc.w	-40,40,-40,0		; d 4
	dc.w	-40,-40,-40,0		; e 5
	dc.w	40,-40,-40,0		; f 6
	dc.w	40,-40,40,0		; g 7
	dc.w	-40,-40,40,0		; h 8

segm:
	dc.w 1,2,3,0,2,3,3,0,3,4,3,0,4,1,3,0,5,6,3,0,6,7,3,0,7,8,3,0

	dc.w 8,5,3,0,2,7,1,0,3,6,1,0,4,5,1,0,1,8,1,0 ; segments AB,BC,CD,DA,EF,FG,GH,HE,BG,CF,DE,AH

dscreen:	dc.l	0
dscreen2:	dc.l	0
hd:		dc.w	0

cube_rot:

	ds.b	4
	ds.b	4
	ds.b	4
	ds.b	4
	ds.b	4
	ds.b	4
	ds.b	4
	ds.b	4

	even
_comment	dc.b	"Ximoon's mulib 0.1.01  dmo 0.01",0	; c'est marrant, mais  correspond  "alpha" :)
even
title		dc.b	"mulib 0.1.01  Dmo",0

	end
